tbb::interface5::internal::flist_iterator< Solist, Value > Class Template Reference

`#include <_concurrent_unordered_impl.h>`

Inheritance diagram for tbb::interface5::internal::flist_iterator< Solist, Value >:
Collaboration diagram for tbb::interface5::internal::flist_iterator< Solist, Value >:

## Public Types

typedef Solist::value_type | value_type
typedef Solist::difference_type | difference_type
typedef Solist::pointer | pointer
typedef Solist::reference | reference

## Public Member Functions

| flist_iterator ()
| flist_iterator (const flist_iterator< Solist, typename Solist::value_type > &other)
flist_iterator & | operator= (const flist_iterator< Solist, typename Solist::value_type > &other)
reference | operator* () const
pointer | operator-> () const
flist_iterator & | operator++ ()
flist_iterator | operator++ (int)

## Protected Member Functions

| flist_iterator (nodeptr_t pnode)
nodeptr_t | get_node_ptr () const

## Protected Attributes

nodeptr_t | my_node_ptr

## Private Types

typedef Solist::nodeptr_t | nodeptr_t

## Friends

template<typename T , typename Allocator >
class | split_ordered_list
template<typename Traits >
class | concurrent_unordered_base
template<class M , typename V >
class | flist_iterator
template<typename M , typename T , typename U >
bool | operator== (const flist_iterator< M, T > &i, const flist_iterator< M, U > &j)
template<typename M , typename T , typename U >
bool | operator!= (const flist_iterator< M, T > &i, const flist_iterator< M, U > &j)

## Detailed Description

### template<class Solist, typename Value>
class tbb::interface5::internal::flist_iterator< Solist, Value >

Definition at line 67 of file _concurrent_unordered_impl.h.

## Member Typedef Documentation

## difference_type

template<class Solist , typename Value >

typedef Solist::difference_type tbb::interface5::internal::flist_iterator< Solist, Value >::difference_type

Definition at line 79 of file _concurrent_unordered_impl.h.

## nodeptr_t

template<class Solist , typename Value >

typedef Solist::nodeptr_t tbb::interface5::internal::flist_iterator< Solist, Value >::nodeptr_t

private

Definition at line 76 of file _concurrent_unordered_impl.h.

## pointer

template<class Solist , typename Value >

typedef Solist::pointer tbb::interface5::internal::flist_iterator< Solist, Value >::pointer

Definition at line 80 of file _concurrent_unordered_impl.h.

## reference

template<class Solist , typename Value >

typedef Solist::reference tbb::interface5::internal::flist_iterator< Solist, Value >::reference

Definition at line 81 of file _concurrent_unordered_impl.h.

## value_type

template<class Solist , typename Value >

typedef Solist::value_type tbb::interface5::internal::flist_iterator< Solist, Value >::value_type

Definition at line 78 of file _concurrent_unordered_impl.h.

## Constructor & Destructor Documentation

## flist_iterator() [1/3]

template<class Solist , typename Value >

tbb::interface5::internal::flist_iterator< Solist, Value >::flist_iterator | ( |  | ) |

inline

Definition at line 83 of file _concurrent_unordered_impl.h.

: my_node_ptr(0) {}
tbb::interface5::internal::flist_iterator::my_node_ptr
nodeptr_t my_node_ptr
Definition: _concurrent_unordered_impl.h:110

## flist_iterator() [2/3]

template<class Solist , typename Value >

tbb::interface5::internal::flist_iterator< Solist, Value >::flist_iterator | ( | const flist_iterator< Solist, typename Solist::value_type > & | other | ) |

inline

Definition at line 84 of file _concurrent_unordered_impl.h.

: my_node_ptr(other.my_node_ptr) {}

## flist_iterator() [3/3]

template<class Solist , typename Value >

tbb::interface5::internal::flist_iterator< Solist, Value >::flist_iterator | ( | nodeptr_t | pnode | ) |

inline protected

Definition at line 107 of file _concurrent_unordered_impl.h.

: my_node_ptr(pnode) {}

## Member Function Documentation

## get_node_ptr()

template<class Solist , typename Value >

nodeptr_t tbb::interface5::internal::flist_iterator< Solist, Value >::get_node_ptr | ( |  | ) | const

inline protected

Definition at line 108 of file _concurrent_unordered_impl.h.

{ return my_node_ptr; }

References tbb::interface5::internal::flist_iterator< Solist, Value >::my_node_ptr.

Referenced by tbb::interface5::internal::split_ordered_list< T, Allocator >::erase_node_impl(), tbb::interface5::internal::split_ordered_list< T, Allocator >::first_real_iterator(), tbb::interface5::internal::split_ordered_list< T, Allocator >::get_iterator(), tbb::interface5::internal::split_ordered_list< T, Allocator >::get_order_key(), tbb::interface5::internal::split_ordered_list< T, Allocator >::get_safe_order_key(), tbb::interface5::internal::split_ordered_list< T, Allocator >::insert_dummy(), tbb::interface5::internal::concurrent_unordered_base< Traits >::internal_merge(), tbb::interface5::internal::concurrent_unordered_base< Traits >::is_initialized(), tbb::interface5::internal::split_ordered_list< T, Allocator >::try_insert(), tbb::interface5::internal::concurrent_unordered_base< Traits >::unsafe_bucket_size(), and tbb::interface5::internal::concurrent_unordered_base< Traits >::unsafe_end().

Here is the caller graph for this function:

## operator*()

template<class Solist , typename Value >

reference tbb::interface5::internal::flist_iterator< Solist, Value >::operator* | ( |  | ) | const

inline

Definition at line 92 of file _concurrent_unordered_impl.h.

{ return my_node_ptr->my_element; }

References tbb::interface5::internal::flist_iterator< Solist, Value >::my_node_ptr.

Referenced by tbb::interface5::internal::solist_iterator< Solist, Value >::operator*().

Here is the caller graph for this function:

## operator++() [1/2]

template<class Solist , typename Value >

flist_iterator& tbb::interface5::internal::flist_iterator< Solist, Value >::operator++ | ( |  | ) |

inline

Definition at line 95 of file _concurrent_unordered_impl.h.

{
my_node_ptr = my_node_ptr->my_next;
return *this;
}

References tbb::interface5::internal::flist_iterator< Solist, Value >::my_node_ptr.

## operator++() [2/2]

template<class Solist , typename Value >

flist_iterator tbb::interface5::internal::flist_iterator< Solist, Value >::operator++ | ( | int |  | ) |

inline

Definition at line 100 of file _concurrent_unordered_impl.h.

{
flist_iterator tmp = *this;
++*this;
return tmp;
}
tbb::interface5::internal::flist_iterator::flist_iterator
friend class flist_iterator
Definition: _concurrent_unordered_impl.h:74

## operator->()

template<class Solist , typename Value >

pointer tbb::interface5::internal::flist_iterator< Solist, Value >::operator-> | ( |  | ) | const

inline

Definition at line 93 of file _concurrent_unordered_impl.h.

{ return &**this; }

## operator=()

template<class Solist , typename Value >

flist_iterator& tbb::interface5::internal::flist_iterator< Solist, Value >::operator= | ( | const flist_iterator< Solist, typename Solist::value_type > & | other | ) |

inline

Definition at line 87 of file _concurrent_unordered_impl.h.

{
my_node_ptr = other.my_node_ptr;
return *this;
}

References tbb::interface5::internal::flist_iterator< Solist, Value >::my_node_ptr.

## Friends And Related Function Documentation

## concurrent_unordered_base

template<class Solist , typename Value >
template<typename Traits >

friend class concurrent_unordered_base

friend

Definition at line 72 of file _concurrent_unordered_impl.h.

## flist_iterator

template<class Solist , typename Value >
template<class M , typename V >

friend class flist_iterator

friend

Definition at line 74 of file _concurrent_unordered_impl.h.

## operator!=

template<class Solist , typename Value >
template<typename M , typename T , typename U >

bool operator!= | ( | const flist_iterator< M, T > & | i,
|  | const flist_iterator< M, U > & | j
| ) |  |

friend

## operator==

template<class Solist , typename Value >
template<typename M , typename T , typename U >

bool operator== | ( | const flist_iterator< M, T > & | i,
|  | const flist_iterator< M, U > & | j
| ) |  |

friend

## split_ordered_list

template<class Solist , typename Value >
template<typename T , typename Allocator >

friend class split_ordered_list

friend

Definition at line 70 of file _concurrent_unordered_impl.h.

## Member Data Documentation

## my_node_ptr

template<class Solist , typename Value >

nodeptr_t tbb::interface5::internal::flist_iterator< Solist, Value >::my_node_ptr

protected

Definition at line 110 of file _concurrent_unordered_impl.h.

Referenced by tbb::interface5::internal::split_ordered_list< T, Allocator >::get_iterator(), tbb::interface5::internal::flist_iterator< Solist, Value >::get_node_ptr(), tbb::interface5::internal::operator!=(), tbb::interface5::internal::flist_iterator< Solist, Value >::operator*(), tbb::interface5::internal::flist_iterator< Solist, Value >::operator++(), tbb::interface5::internal::flist_iterator< Solist, Value >::operator=(), tbb::interface5::internal::solist_iterator< Solist, Value >::operator=(), and tbb::interface5::internal::operator==().

The documentation for this class was generated from the following file:

- _concurrent_unordered_impl.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.